Subject: bug#46495: 28.0.50; [native-comp] Build fails for 32bit --with-wide-int

From: Eli Zaretskii <[email-masked]>
Date: Wed, 31 Mar 2021 15:27:46 +0300

> From: Andrea Corallo <[email-masked]>
> Cc: [email-masked], [email-masked], [email-masked]
> Date: Wed, 31 Mar 2021 12:16:14 +0000
> 
> >> OTOH I understand we can't update gdb for all users that might want
> >> to help debugging an issue, but I don't like very much the idea to
> >> have comp-debug 1 as default on every system.  What about having 1
> >> as default only on Windows?  WDYT?
> >
> > In general, I'd prefer these settings to be the same on all platforms,
> > although it isn't a strong feeling in this case.  But I'm curious why
> > you are so against doing that by default on other systems.  Can you
> > explain?
> 
> Nothing special, just that that as on GNU/Linux we can produce
> backtraces without debug symbols so seams to me it would be a waste of
> space to have them always present just for this reason.

Well, using comp-debug = 1 produces minor improvements also on
GNU/Linux, as it shows the values of arguments of the
natively-compiled functions instead of just "()".  Example:

  #75 0x01260cad in funcall_subr (subr=0x1730200 <Sfuncall_interactively>,
      numargs=3, args=0x82f028) at eval.c:3064
  #76 0x01260805 in Ffuncall (nargs=4, args=0x82f020) at eval.c:3009
  #77 0x0125f238 in Fapply (nargs=3, args=0x82f1a8) at eval.c:2639
  #78 0x01250e54 in Fcall_interactively (function=XIL(0x44e24ec),
      record_flag=XIL(0), keys=XIL(0xa00000000678d168)) at callint.c:353
  #79 0x70f1ae41 in F636f6d6d616e642d65786563757465_command_execute_0 (
      par_0=72230124, par_1=0, par_2=0, par_3=0)  <<<<<<<<<<<<<<<<<<<<<<<<<
      at d:/gnu/git/emacs/native-comp/native-lisp/28.0.50-c99426db/simple-fab5b0cf-db78b289.c:23993

But I'm okay with leaving it at zero except on Windows for now, we can
always revisit this later.

> > Anyway, I've compiled the relevant files with comp-debug = 1, and the
> > problems with backtraces are now completely gone.  So I think we can
> > more or less close this issue (modulo changing the meanings of
> > comp-debug and the decision regarding the default value).
> 
> Sounds good, if my proposal of the new 4 values is acceptable for you
> and we decide on the default one I can proceed with that.

Yes, let's make that change.

Please also look into the issue with temporary *.el files I reported
earlier.

Thanks.